﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HeuristicLab.PluginInfrastructure;
using PluginDeploymentService = HeuristicLab.PluginInfrastructure.Advanced.DeploymentService;

namespace HeuristicLab.DeploymentService.AdminClient {
  public partial class ServerPluginView : PluginView {
    private PluginDeploymentService.PluginDescription plugin;

    public ServerPluginView() {
      InitializeComponent();
    }

    public ServerPluginView(PluginDeploymentService.PluginDescription plugin) {
      InitializeComponent();
      this.plugin = plugin;
      UpdateControls();
    }

    public void UpdateControls() {
      if (plugin == null) {
        this.Controls.Clear();
        var label = new Label();
        label.Dock = DockStyle.Fill;
        label.Text = "No matching server plugin";
        this.Controls.Add(label);
      } else {
        nameTextBox.Text = plugin.Name;
        versionTextBox.Text = plugin.Version.ToString();
        contactTextBox.Text = plugin.ContactInformation;
        foreach (PluginDeploymentService.PluginDescription dependency in plugin.Dependencies) {
          dependenciesListView.Items.Add(new ListViewItem(new string[] { dependency.Name, dependency.Version.ToString() }));
        }
        licenseButton.Enabled = !string.IsNullOrEmpty(plugin.LicenseText);
      }
    }

    private void licenseButton_Click(object sender, EventArgs e) {
      LicenseView view = new LicenseView(plugin.Name, plugin.Version.ToString(), plugin.LicenseText);
      view.Show();
    }
  }
}
